from atelier.invlib import setup_from_tasks

ns = setup_from_tasks(
    globals(),
    'lino_book',
    tolerate_sphinx_warnings=False,
    blogref_url="https://luc.lino-framework.org",
    revision_control_system='git',
    test_command="pytest tests docs",  # more options in file pytest.ini
    make_docs_command='python make_docs.py',
    demo_projects=[
        # 'lino_book.projects.gerd',
        # 'lino_book.projects.mathieu',
        # 'lino_welcht.demo',
        'lino_book.projects.polls',
        'lino_book.projects.polls2',
        'lino_book.projects.voga1',
        'lino_book.projects.voga2',
        'lino_book.projects.voga3',
        'lino_book.projects.edmund',
        'lino_book.projects.combo',
        'lino_book.projects.db_overview',
        'lino_book.projects.chooser',
        'lino_book.projects.watch',
        'lino_book.projects.watch2',
        'lino_book.projects.workflows',
        'lino_book.projects.belref',
        'lino_book.projects.estref',
        'lino_book.projects.polly',
        'lino_book.projects.events',
        'lino_book.projects.i18n',
        'lino_book.projects.lets1',
        'lino_book.projects.lets2',
        'lino_book.projects.min1',
        'lino_book.projects.min2',
        'lino_book.projects.min3',
        'lino_book.projects.min9',
        'lino_book.projects.mti',
        'lino_book.projects.nomti',
        'lino_book.projects.cms1',
        'lino_book.projects.noi1e',  # must prep before cosi1
        'lino_book.projects.noi2',
        'lino_book.projects.cosi1',  # must prep after noi1e
        'lino_book.projects.cosi2',
        'lino_book.projects.cosi3',
        'lino_book.projects.cosi4',
        'lino_book.projects.cosi5',
        'lino_book.projects.chatter',
        'lino_book.projects.avanti1',
        'lino_book.projects.avanti2',
        'lino_book.projects.ovfields',
        'lino_book.projects.anna',
        'lino_book.projects.liina',
        'lino_book.projects.tera1',
        'lino_book.projects.gfktest',
        'lino_book.projects.actions',
        'lino_book.projects.actors',
        'lino_book.projects.tables',
        'lino_book.projects.vtables',
        'lino_book.projects.integer_pk',
        'lino_book.projects.float2decimal',
        'lino_book.projects.myroles',
        'lino_book.projects.mldbc',
        'lino_book.projects.de_BE',
        'lino_book.projects.auto_create',
        'lino_book.projects.addrloc',
        'lino_book.projects.babel_tutorial',
        'lino_book.projects.confdirs',
        'lino_book.projects.diamond',
        'lino_book.projects.public',
        # 'lino_openui5.projects.teamUi5',
        # 'lino_openui5.projects.lydiaUi5',

        # 'lino_book/projects/diamond2',
        # 'lino_book/projects/sendchanges',
        # 'lino_book/projects/pisa',
    ],
    cleanable_files=[
        'docs/rss_entry_fragments/*', 'docs/api/lino.*', 'docs/api/lino_xl.*',
        'docs/api/lino_noi.*', 'docs/api/lino_cosi.*',
        'docs/api/lino_avanti.*', 'docs/api/lino_vilma.*',
        'docs/api/lino_tera.*', 'docs/api/lino_care.*', 'docs/api/lino_cms.*',
        'docs/api/lino_voga.*', 'docs/api/lino_amici.*', 'docs/api/lino_book.*'
    ])
